
#include "analogDigital.h"

uint8_t AnalogDigital::aktuellerKanal = 0;
bool AnalogDigital::kanalFrei = true;

uint8_t AnalogDigital::mux;
uint8_t AnalogDigital::ref;
uint8_t AnalogDigital::la;

void AnalogDigital::setupStatic()
{

  ADCSRA &= ~7;
  ADCSRA |= ADC_PRESCALER;

  ADCSRB = 5; // Timer/Counter1 compare match B
  setLeftAdjust(0);
  setRef(3); // Internal 1.1V voltage reference with external capacitor at AREF pin
  setAdcAdmux();
  

}

void AnalogDigital::setMux(uint8_t mux)
{
  AnalogDigital::mux = mux & 7;
  AnalogDigital::setAdcAdmux();
}

void AnalogDigital::setRef(uint8_t ref)
{
  AnalogDigital::ref = ref & 3;
}

void AnalogDigital::setLeftAdjust(uint8_t la)
{
  AnalogDigital::la = la & 1;
}

void AnalogDigital::setAdcAdmux()
{
  ADMUX = (AnalogDigital::mux << MUX0) |
          (AnalogDigital::ref << REFS0) |
          (AnalogDigital::la << ADLAR);
}